﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace SwitchLayers
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.CurrentExtent = new RectangleShape(-125, 72, 50, -46);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                ShapeFileFeatureLayer layer1 = new ShapeFileFeatureLayer(MapPath("~/app_data/layer1.shp"));
                layer1.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.FromArgb(100, GeoColor.SimpleColors.Green));
                layer1.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                ShapeFileFeatureLayer layer2 = new ShapeFileFeatureLayer(MapPath("~/app_data/layer2.shp"));
                layer2.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.FromArgb(100, GeoColor.SimpleColors.Red));
                layer2.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                LayerOverlay layerOverlay = new LayerOverlay("BaseLayer");
                layerOverlay.Layers.Add("Layer1", layer1);
                layerOverlay.Layers.Add("Layer2", layer2);

                layer1.Open();
                layer2.Open();

                Map1.CurrentExtent = ExtentHelper.GetBoundingBoxOfItems(new BaseShape[] { layer1.GetBoundingBox(), layer2.GetBoundingBox() });
                Map1.CustomOverlays.Add(layerOverlay);
            }
        }

        public void LayerSwitched(object sender, EventArgs e)
        {
            CheckBox checkBox = (CheckBox)sender;
            string layerKey = checkBox.Text;
            LayerOverlay overlay = (LayerOverlay)Map1.CustomOverlays["BaseLayer"];
            Layer featureLayer = overlay.Layers[layerKey];
            featureLayer.IsVisible = !featureLayer.IsVisible;
            overlay.Redraw();
        }
    }
}
